//Diagrammtest für Kennlinien mit Röhren NT
unit Unit1;
{$mode objfpc}{$H+}
interface
uses
  Classes, SysUtils, SdfData, db, sqldb, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, TAGraph, TASeries, TADbSource, TASources, TATools;
type
  { TForm1 }
  TForm1 = class(TForm)
    Chart1: TChart;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointCrosshairTool1: TDataPointCrosshairTool;
    DataSrc1: TDataSource;
    ChartSrc1: TDbChartSource;
    Label1: TLabel;
    ListChartSource1: TListChartSource;
    Sdf1: TSdfDataSet;
    DataSerie1: TLineSeries;
    procedure ChartToolset1DataPointCrosshairTool1Draw(
      ASender: TDataPointDrawTool);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

//Initialisation
procedure TForm1.FormShow(Sender: TObject);
var
  decSep: Char;
begin
  Sdf1.FileName:='Tab01.dat';
  Sdf1.Active:= true;

  // Werte aus der DB in eine ListChartSource kopieren (mit DBChartSource ist die Performance grottenschlecht...)
  decSep := DefaultFormatSettings.DecimalSeparator;
  DefaultFormatSettings.DecimalSeparator := '.';
  ListChartSource1.CopyFrom(ChartSrc1);
  DefaultFormatSettings.DecimalSeparator:= decSep;

  // ListChartSource1 als Datenquelle in der Series verwenden
  DataSerie1.Source := ListChartSource1;
end;

procedure TForm1.ChartToolset1DataPointCrosshairTool1Draw(
  ASender: TDataPointDrawTool);
var
  x, y: Double;
begin
  if ASender.Series <> nil then
  begin
    x := (ASender.Series as TLineSeries).XValue[ASender.PointIndex];
    y := (ASender.Series as TLineSeries).YValue[ASender.PointIndex];
    Label1.Caption := Format('Ug = %.3f V, Ia = %.3f mA', [x, y]);
  end else
    Label1.Caption := '';
end;

end.

